[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
[PATCH v2 07/17] 20_ppc_terminfo.in: Migrate ieee1275/PPC from Yaboot to
From: |
Leo Sandoval |
Subject: |
[PATCH v2 07/17] 20_ppc_terminfo.in: Migrate ieee1275/PPC from Yaboot to Grub2 |
Date: |
Mon, 7 Oct 2024 12:17:58 -0600 |
From: Mark Hamzy <hamzy@us.ibm.com>
Add configuration support for ieee1275/PPC ofconsole serial terminal.
Signed-off-by: Mark Hamzy <hamzy@us.ibm.com>
Signed-off-by: Robbie Harwood <rharwood@redhat.com>
---
Makefile.util.def | 7 ++
util/grub.d/20_ppc_terminfo.in | 114 +++++++++++++++++++++++++++++++++
2 files changed, 121 insertions(+)
create mode 100644 util/grub.d/20_ppc_terminfo.in
diff --git a/Makefile.util.def b/Makefile.util.def
index 9432365a9..09bfcadd9 100644
--- a/Makefile.util.def
+++ b/Makefile.util.def
@@ -517,6 +517,13 @@ script = {
installdir = grubconf;
};
+script = {
+ name = '20_ppc_terminfo';
+ common = util/grub.d/20_ppc_terminfo.in;
+ installdir = grubconf;
+ condition = COND_HOST_LINUX;
+};
+
script = {
name = '30_os-prober';
common = util/grub.d/30_os-prober.in;
diff --git a/util/grub.d/20_ppc_terminfo.in b/util/grub.d/20_ppc_terminfo.in
new file mode 100644
index 000000000..10d665868
--- /dev/null
+++ b/util/grub.d/20_ppc_terminfo.in
@@ -0,0 +1,114 @@
+#! /bin/sh
+set -e
+
+# grub-mkconfig helper script.
+# Copyright (C) 2006,2007,2008,2009,2010 Free Software Foundation, Inc.
+#
+# GRUB is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# GRUB is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GRUB. If not, see <http://www.gnu.org/licenses/>.
+
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+bindir=@bindir@
+libdir=@libdir@
+. "@datadir@/@PACKAGE@/grub-mkconfig_lib"
+
+export TEXTDOMAIN=@PACKAGE@
+export TEXTDOMAINDIR=@localedir@
+
+X=80
+Y=24
+TERMINAL=ofconsole
+
+argument () {
+ opt=$1
+ shift
+
+ if test $# -eq 0; then
+ echo "$0: option requires an argument -- '$opt'" 1>&2
+ exit 1
+ fi
+ echo $1
+}
+
+check_terminfo () {
+
+ while test $# -gt 0
+ do
+ option=$1
+ shift
+
+ case "$option" in
+ terminfo | TERMINFO)
+ ;;
+
+ -g)
+ NEWXY=`argument $option "$@"`
+ NEWX=`echo $NEWXY | cut -d x -f 1`
+ NEWY=`echo $NEWXY | cut -d x -f 2`
+
+ if [ ${NEWX} -ge 80 ] ; then
+ X=${NEWX}
+ else
+ echo "Warning: ${NEWX} is less than the minimum size of 80"
+ fi
+
+ if [ ${NEWY} -ge 24 ] ; then
+ Y=${NEWY}
+ else
+ echo "Warning: ${NEWY} is less than the minimum size of 24"
+ fi
+
+ shift
+ ;;
+
+ *)
+# # accept console or ofconsole
+# if [ "$option" != "console" -a "$option" != "ofconsole" ] ; then
+# echo "Error: GRUB_TERMINFO unknown console: $option"
+# exit 1
+# fi
+# # perfer console
+# TERMINAL=console
+ # accept ofconsole
+ if [ "$option" != "ofconsole" ] ; then
+ echo "Error: GRUB_TERMINFO unknown console: $option"
+ exit 1
+ fi
+ # perfer console
+ TERMINAL=ofconsole
+ ;;
+ esac
+
+ done
+
+}
+
+if ! uname -m | grep -q ppc ; then
+ exit 0
+fi
+
+if [ "x${GRUB_TERMINFO}" != "x" ] ; then
+ F1=`echo ${GRUB_TERMINFO} | cut -d " " -f 1`
+
+ if [ "${F1}" != "terminfo" ] ; then
+ echo "Error: GRUB_TERMINFO is set to \"${GRUB_TERMINFO}\" The first word
should be terminfo."
+ exit 1
+ fi
+
+ check_terminfo ${GRUB_TERMINFO}
+fi
+
+cat << EOF
+ terminfo -g ${X}x${Y} ${TERMINAL}
+EOF
--
2.46.2
- [PATCH v2 00/17] First Distro-agnostic series taken from Fedora Rawhide, Leo Sandoval, 2024/10/07
- [PATCH v2 02/17] term/terminfo: for ppc, reset console display attr when clear screen, Leo Sandoval, 2024/10/07
- [PATCH v2 04/17] configure.ac: Move bash completion script, Leo Sandoval, 2024/10/07
- [PATCH v2 08/17] normal: Add fw_path variable (revised), Leo Sandoval, 2024/10/07
- [PATCH v2 03/17] ieee1275: Disable GRUB video support for IBM power machines, Leo Sandoval, 2024/10/07
- [PATCH v2 07/17] 20_ppc_terminfo.in: Migrate ieee1275/PPC from Yaboot to Grub2,
Leo Sandoval <=
- [PATCH v2 09/17] commands: Pass "\x[[:hex:]][[:hex:]]" straight through unmolested., Leo Sandoval, 2024/10/07
- [PATCH v2 10/17] 10_linux.in: Add devicetree loading, Leo Sandoval, 2024/10/07
- [PATCH v2 05/17] misc: Make "exit" take a return code., Leo Sandoval, 2024/10/07
- [PATCH v2 12/17] Makefile.common: Add .eh_frame to list of relocations stripped, Leo Sandoval, 2024/10/07
- [PATCH v2 11/17] 00_header.in: Enable pager by default. (#985860), Leo Sandoval, 2024/10/07
- [PATCH v2 14/17] normal/main: fw_path prefix when fallback searching for grub config, Leo Sandoval, 2024/10/07
- [PATCH v2 17/17] normal/main: Try $prefix if $fw_path doesn't work., Leo Sandoval, 2024/10/07